base_height = 20.0;
base_width  = 80.0;

table_depth = 80.0;

guide_width  = 20.0;
guide_depth  = 80.0;
guide_height = 20.0;

notch_width  = 30.0;
notch_depth  = 10.0;

wall_depth  = 20.0;
wall_height = 30.0;

wall_y = table_depth + notch_width;

difference() {
    union() {
        base();
        guide();
        wall();
        supports();
    }
    notch();
}

module base() {
    depth = table_depth + notch_width + wall_depth + wall_height;
    
    cube([base_width, depth, base_height]);
}

module guide() {
    translate([0.0, table_depth - guide_depth, base_height])
    cube([guide_width, guide_depth, guide_height]);
}

module wall() {
    translate([0.0, wall_y, base_height])
    cube([base_width, wall_depth, wall_height]);
}

module supports() {
    y = wall_y + wall_depth;

    union() {
        translate([0.0, y, base_height])
        support();

        translate([base_width - wall_depth, y, base_height])
        support();
    }
}

module support() {
    polyhedron(
        [
            [0.0, 0.0, 0.0],
            [wall_depth, 0.0, 0.0],
            [wall_depth, wall_height, 0.0],
            [0.0, wall_height, 0.0],
            [0.0, 0.0, wall_height],
            [wall_depth, 0.0, wall_height]
        ],
        [
            [0, 1, 2, 3],
            [0, 4, 5, 1],
            [2, 5, 4, 3],
            [0, 3, 4],
            [1, 5, 2]
        ]
    );
}

module notch() {
    translate([0.0, table_depth, base_height - notch_depth])
    cube([base_width, notch_width, notch_depth]);
}
